<?php
/**
*
* @package arcade
* @version $Id: config.php 362 2008-09-05 13:51:34Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* Some config values so the script can be used for different mods.
* Currently only setup to add parent modules to .MODS tab in ACP
* then add the mods modules to this new parent.
* EDIT VALUES BELOW
*/

$CFG = array(
	'mod_title'					=> 'phpBB Arcade',
	'mod_version'				=> '0.7.0',
	'mod_copyright'				=> 'Powered by phpBB Arcade 0.7.0 BETA &copy; 2008 <a href="http:// www.jeffrusso.net">JRSweets</a><br />',
	'mod_dir'					=> 'arcade_install',
	'clear_cache_install'		=> true,
	'clear_cache_uninstall'		=> true,
	'clear_cache_update'		=> true,
	'data_file'					=> 'schemas/schema_data.sql',
	'remove_data_file'			=> 'schemas/remove_schema_data.sql',
	'pg_remove_data_file'		=> 'schemas/postgres_remove_schema_data.sql',
	'parent_module_remove'		=> array('ACP_ARCADE', 'ACP_CAT_ARCADE', 'ACP_CAT_ARCADE_CONFIGURATION', 'ACP_CAT_ARCADE_GAMES', 'ACP_CAT_ARCADE_UTILITIES', 'ACP_CAT_ARCADE_PERMISSION_ROLES', 'ACP_CAT_ARCADE_PERMISSIONS', 'ACP_CAT_ARCADE_PERMISSION_MASKS','UCP_ARCADE'),
	'module_remove'				=> array('arcade', 'arcade_manage', 'arcade_games', 'arcade_utilities', 'arcade_permission_roles', 'arcade_permissions'),
	'permission_options'		=> array(
		'local'		=> array(),
		'global'	=> array('a_cauth', 'a_arcade_settings', 'a_arcade_game', 'a_arcade_delete_game', 'a_arcade_cat', 'a_arcade_delete_cat', 'a_arcade_scores', 'a_arcade_utilities'),
	),
	'arcade_permission_options'	=> array(
		'local'		=> array('c_', 'c_list', 'c_view', 'c_play', 'c_score', 'c_rate', 'c_comment', 'c_download', 'c_ignorecontrol', 'c_resolution'),
		'global'	=> array(),
	),
	'mod_modules'				=> array(
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_CONFIGURATION',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_SETTINGS',
					'module_mode' 		=> 'settings',
					'module_auth' 		=> 'acl_a_arcade_settings',
				),
				array(
					'module_basename'	=> 'arcade_manage',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_MANAGE_ARCADE',
					'module_mode' 		=> 'manage',
					'module_auth' 		=> 'acl_a_arcade_cat'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_USER_GUIDE',
					'module_mode' 		=> 'user_guide',
					'module_auth' 		=> ''
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_GAMES',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_ADD_GAMES',
					'module_mode' 		=> 'add_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_DOWNLOADS',
					'module_mode' 		=> 'downloads',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_EDIT_GAMES',
					'module_mode' 		=> 'edit_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_EDIT_SCORES',
					'module_mode' 		=> 'edit_scores',
					'module_auth' 		=> 'acl_a_arcade_scores'
				),
				array(
					'module_basename'	=> 'arcade_games',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UNPACK_GAMES',
					'module_mode' 		=> 'unpack_games',
					'module_auth' 		=> 'acl_a_arcade_game'
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_UTILITIES',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_CREATE_INSTALL',
					'module_mode' 		=> 'create_install',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_CONVERT_INSTALL',
					'module_mode' 		=> 'convert_install',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_DOWNLOAD_STATS',
					'module_mode' 		=> 'download_stats',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
				array(
					'module_basename'	=> 'arcade_utilities',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_UTILITIES_ERRORS',
					'module_mode' 		=> 'errors',
					'module_auth' 		=> 'acl_a_arcade_utilities'
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSION_ROLES',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permission_roles',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_CAT_ROLES',
					'module_mode' 		=> 'cat_roles',
					'module_auth' 		=> 'acl_a_cauth && acl_a_roles',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSIONS',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '0',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_PERMISSION_TRACE',
					'module_mode' 		=> 'trace',
					'module_auth' 		=> 'acl_a_viewauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_category_local',
					'module_auth' 		=> 'acl_a_cauth && (acl_a_authusers || acl_a_authgroups)',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_USERS_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_user_local',
					'module_auth' 		=> 'acl_a_authgroups && acl_a_cauth',
				),
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_ARCADE_GROUPS_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'setting_group_local',
					'module_auth' 		=> 'acl_a_authusers && acl_a_cauth',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'acp',
				'module_langname' 	=> 'ACP_CAT_ARCADE_PERMISSION_MASKS',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade_permissions',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'acp',
					'module_langname' 	=> 'ACP_VIEW_ARCADE_CATEGORY_PERMISSIONS',
					'module_mode' 		=> 'view_category_local',
					'module_auth' 		=> 'acl_a_viewauth',
				),
			),
		),
		array(
			'parent_module_data'	=> array(
				'module_basename' 	=> '',
				'module_enabled'	=> '1',
				'module_display' 	=> '1',
				'parent_id' 		=> '0',
				'module_class' 		=> 'ucp',
				'module_langname' 	=> 'UCP_ARCADE',
				'module_mode' 		=> '',
				'module_auth' 		=> '',
			),
			'module_data'			=> array(
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_ARCADE_SETTINGS',
					'module_mode' 		=> 'settings',
					'module_auth' 		=> ''
				),
				array(
					'module_basename'	=> 'arcade',
					'module_enabled' 	=> '1',
					'module_display' 	=> '1',
					'module_class' 		=> 'ucp',
					'module_langname' 	=> 'UCP_ARCADE_FAVORITES',
					'module_mode' 		=> 'favorites',
					'module_auth' 		=> ''
				),
			),
		),
	),
	// Schema Changes for install
	'schema_changes'=> array(
		'add_columns'		=> array(
			$table_prefix . 'users'	=> array(
				'user_arcade_permissions'	=> array('MTEXT', ''),
				'user_arcade_perm_from'		=> array('UINT', 0),
				'user_arcade_pm'			=> array('TINT:1', 1),
				'games_per_page'			=> array('USINT', 0),
				'games_sort_dir'			=> array('VCHAR_UNI:1', 'a'),
				'games_sort_order'			=> array('VCHAR_UNI:1', 'n'),
			),
		),
	),
	// Schema Changes for uninstall
	'remove_schema_changes'	=> array(
		'drop_columns'		=> array(
			$table_prefix . 'users'	=> array('user_arcade_permissions', 'user_arcade_perm_from', 'user_arcade_pm', 'games_per_page', 'games_sort_dir', 'games_sort_order'),
		),
	),
	// Schema Changes between versions
	'update_schema_changes'	=> array(
		// Change from version 0.1.0 to 0.2.0
		'0.2.0' => array(
			'drop_keys'		=> array(
				$table_prefix . 'arcade_scores'	=> array(
					'KEYS'			=> 'game_id', 'user_id',
				),
				$table_prefix . 'arcade_game_rating'	=> array(
					'KEYS'			=> 'game_id', 'user_id',
				),
				$table_prefix . 'arcade_favorites'	=> array(
					'KEYS'			=> 'user_id', 'game_id',
				),
			),
			'add_primary_keys'		=> array(
				$table_prefix . 'arcade_scores'	=> array(
					'PRIMARY_KEY'	=> 'game_id', 'user_id',
				),
			$table_prefix . 'arcade_game_rating'	=> array(
					'PRIMARY_KEY'	=> 'game_id', 'user_id',
				),
			$table_prefix . 'arcade_favorites'	=> array(
					'PRIMARY_KEY'	=> 'user_id', 'game_id',
				),
			),
			'add_columns'		=> array(
				$table_prefix . 'users'	=> array(
					'user_arcade_pm'			=> array('TINT:1', 1),
					'games_per_page'			=> array('USINT', 0),
					'games_sort_dir'			=> array('VCHAR_UNI:1', 'a'),
					'games_sort_order'			=> array('VCHAR_UNI:1', 'n'),
				),
				$table_prefix . 'arcade_errors'	=> array(
					'error_ip'					=> array('VCHAR:40', ''),
				),
			),
		),
		// Change from version 0.2.0 to 0.3.0
		'0.3.0'	=> array(
			'change_columns'		=> array(
				$table_prefix . 'arcade_games'	=> array(
					'game_image'		=> array('VCHAR', ''),
					'game_desc'			=> array('TEXT', ''),
				),
			),
		),
		// Change from version 0.3.0 to 0.3.1
		'0.3.1'	=> array(
			'add_columns'		=> array(
				$table_prefix . 'arcade_games'	=> array(
					'game_download'		=> array('TINT:1', 1),
				),
				$table_prefix . 'arcade_categories'	=> array(
					'cat_download'		=> array('TINT:1', 1),
				),
			),
		),
		// Change from version 0.3.2 to 0.4.0
		'0.4.0'	=> array(
			'change_columns'		=> array(
				$table_prefix . 'arcade_games'	=> array(
					'game_highscore'	=> array('PDECIMAL:25', 0.00),
				),
				$table_prefix . 'arcade_categories'	=> array(
					'cat_last_play_score'	=> array('PDECIMAL:25', 0.00),
				),
				$table_prefix . 'arcade_scores'	=> array(
					'score'	=> array('PDECIMAL:25', 0.00),
				),
				$table_prefix . 'arcade_errors'	=> array(
					'score'	=> array('PDECIMAL:25', 0.00),
				),
			),
		),
		// Change from version 0.4.1 to 0.4.2
		'0.4.2'	=> array(
			'add_columns'		=> array(
				$table_prefix . 'arcade_games'	=> array(
					'game_download_total'	=> array('UINT', 0),
					'game_name_clean'		=> array('VCHAR', ''),
				),
			),
		),
		// Change from version 0.4.2 to 0.4.3
		'0.4.3'	=> array(
			'add_columns'		=> array(
				$table_prefix . 'arcade_download'	=> array(
					'download_time'		=> array('TIMESTAMP', 0),
				),
			),
		),
		// Change from version 0.4.5 to 0.5.0
		'0.5.0'	=> array(
			'add_columns'		=> array(
				$table_prefix . 'arcade_categories'	=> array(
					'display_subcat_list'		=> array('BOOL', 1),
				),
				$table_prefix . 'users'	=> array(
					'user_arcade_permissions'			=> array('MTEXT', ''),
					'user_arcade_perm_from'			=> array('UINT', 0),
				),
			),
		),
		// Change from version 0.6.0 to 0.6.1
		'0.6.1'	=> array(
			'add_columns'		=> array(
				$table_prefix . 'arcade_games'	=> array(
					'game_filesize'		=> array('UINT:20', 0),
				),
			),
		),
	),
	'update_permission_options' => array(
		'0.4.5'	=> array(
			'local'		=> array(),
			'global'	=> array('u_arcade_ignore_playcontrol'),
		),
		'0.5.0'	=> array(
			'local'		=> array(),
			'global'	=> array('a_cauth'),
		),
	),
	'update_arcade_permission_options' => array(
		'0.6.0'	=> array(
			'local'		=> array('c_popup'),
			'global'	=> array(),
		),
	),
);

?>