<?php
/**
*
* @package arcade
* @version $Id: install_check.php 365 2008-09-05 14:14:22Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', 1);
$phpEx = substr(strrchr(__FILE__, '.'), 1);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
include($phpbb_root_path . 'common.'.$phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// is the user logged in?
// This might be looked at later if people have problems, but I guess only the founder
// should be using ftp and installing scripts anyway.
if ($user->data['user_type'] != USER_FOUNDER)
{
	trigger_error('You are not authorized to use this script.<br /><br />Please note to use the script the following requirements must be met.  First you must be logged in to the site and second you must have the user type founder. If you are logged in and are the founder then you have incorrect cookie settings in the acp. Please check the cookie domain setting. If your site url is <strong>http://www.example.com</strong> then the cookie domain should be <strong>.example.com</strong>.');
}

// Empty cache...
$cache->purge();

$arcade = new arcade_check();
$arcade->install_header("Arcade Installation Checking...", "phpBB Arcade");
$arcade->check_tables();
$arcade->check_alter_db();
$arcade->check_files();
$arcade->check_edits();
$arcade->check_modules();
$arcade->check_permissions();
$arcade->display_done();
$arcade->install_footer();
exit;

class arcade_check
{
	var $arcade_tables = array();
	var $arcade_files = array();
	var $arcade_edits = array();
	var $arcade_permissions = array();
	var $phpbb_permissions = array();
	var $arcade_modules = array();
	var $arcade_alter_db = array();
	var $no_errors = true;

	function arcade_check()
	{
		global $phpbb_root_path, $phpEx, $user, $table_prefix;

		require($phpbb_root_path . 'includes/functions_install.' . $phpEx);

		define('ACL_ARCADE_GROUPS_TABLE',		$table_prefix . 'acl_arcade_groups');
		define('ACL_ARCADE_OPTIONS_TABLE',		$table_prefix . 'acl_arcade_options');
		define('ACL_ARCADE_ROLES_DATA_TABLE',	$table_prefix . 'acl_arcade_roles_data');
		define('ACL_ARCADE_ROLES_TABLE',		$table_prefix . 'acl_arcade_roles');
		define('ACL_ARCADE_USERS_TABLE',		$table_prefix . 'acl_arcade_users');
		define('ARCADE_ACCESS_TABLE',			$table_prefix . 'arcade_access');
		define('ARCADE_CATS_TABLE',				$table_prefix . 'arcade_categories');
		define('ARCADE_DOWNLOAD_TABLE',			$table_prefix . 'arcade_download');
		define('ARCADE_CONFIG_TABLE',			$table_prefix . 'arcade_config');
		define('ARCADE_GAMES_TABLE',			$table_prefix . 'arcade_games');
		define('ARCADE_FAVS_TABLE', 			$table_prefix . 'arcade_favorites');
		define('ARCADE_RATING_TABLE', 			$table_prefix . 'arcade_game_rating');
		define('ARCADE_SESSIONS_TABLE', 		$table_prefix . 'arcade_sessions');
		define('ARCADE_SCORES_TABLE', 			$table_prefix . 'arcade_scores');
		define('ARCADE_ERRORS_TABLE', 			$table_prefix . 'arcade_errors');

		$this->arcade_tables = array(
			ACL_ARCADE_GROUPS_TABLE,
			ACL_ARCADE_OPTIONS_TABLE,
			ACL_ARCADE_ROLES_DATA_TABLE,
			ACL_ARCADE_ROLES_TABLE,
			ACL_ARCADE_USERS_TABLE,
			ARCADE_ACCESS_TABLE,
			ARCADE_CATS_TABLE,
			ARCADE_CONFIG_TABLE,
			ARCADE_DOWNLOAD_TABLE,
			ARCADE_GAMES_TABLE,
			ARCADE_FAVS_TABLE,
			ARCADE_RATING_TABLE,
			ARCADE_SESSIONS_TABLE,
			ARCADE_SCORES_TABLE,
			ARCADE_ERRORS_TABLE,
		);

		$this->arcade_files = array(
			'arcade.php',
			'newscore.php',
			'viewgame.php',
			'adm/style/acp_arcade.html',
			'adm/style/acp_arcade_games.html',
			'adm/style/acp_arcade_manage.html',
			'adm/style/acp_arcade_permissions.html',
			'adm/style/acp_arcade_utilities.html',
			'adm/style/confirm_body_move_arcade_games.html',
			'includes/auth_arcade.php',
			'includes/acp/acp_arcade.php',
			'includes/acp/acp_arcade_games.php',
			'includes/acp/acp_arcade_manage.php',
			'includes/acp/acp_arcade_permissions.php',
			'includes/acp/acp_arcade_permission_roles.php',
			'includes/acp/acp_arcade_utilities.php',
			'includes/acp/auth_arcade.php',
			'includes/acp/info/acp_arcade.php',
			'includes/acp/info/acp_arcade_games.php',
			'includes/acp/info/acp_arcade_manage.php',
			'includes/acp/info/acp_arcade_permissions.php',
			'includes/acp/info/acp_arcade_permission_roles.php',
			'includes/acp/info/acp_arcade_utilities.php',
			'includes/arcade/arcade_admin_class.php',
			'includes/arcade/arcade_cache.php',
			'includes/arcade/arcade_class.php',
			'includes/arcade/arcade_common.php',
			'includes/arcade/arcade_compress.php',
			'includes/arcade/arcade_constants.php',
			'includes/arcade/arcade_download.php',
			'includes/arcade/arcade_games.php',
			'includes/arcade/arcade_play.php',
			'includes/arcade/arcade_protect.php',
			'includes/arcade/arcade_score.php',
			'includes/arcade/arcade_stats.php',
			'includes/arcade/functions_arcade.php',
			'includes/arcade/swfobject.js',
			'includes/arcade/images/1st.gif',
			'includes/arcade/images/2nd.gif',
			'includes/arcade/images/3rd.gif',
			'includes/arcade/images/favorite.gif',
			'includes/arcade/images/noavatar.gif',
			'includes/arcade/images/remove_favorite.gif',
			'includes/arcade/images/star1.gif',
			'includes/arcade/images/star2.gif',
			'includes/arcade/scoretype/ibpro.php',
			'includes/arcade/scoretype/ibprov3.php',
			'includes/arcade/scoretype/v3arcade.php',
			'includes/ucp/ucp_arcade.php',
			'includes/ucp/info/ucp_arcade.php',
			'language/en/acp/permissions_arcade.php',
			'language/en/mods/arcade.php',
			'language/en/mods/help_arcade.php',
			'language/en/mods/info_acp_arcade.php',
			'language/en/mods/info_ucp_arcade.php',
			'styles/prosilver/template/ucp_arcade_settings.html',
			'styles/prosilver/template/ucp_arcade_favorites.html',
			'styles/prosilver/template/arcade/arcade_download_body.html',
			'styles/prosilver/template/arcade/arcade_header_body.html',
			'styles/prosilver/template/arcade/arcade_index_body.html',
			'styles/prosilver/template/arcade/arcade_jumpbox.html',
			'styles/prosilver/template/arcade/arcade_list_body.html',
			'styles/prosilver/template/arcade/arcade_login_cat.html',
			'styles/prosilver/template/arcade/arcade_online_body.html',
			'styles/prosilver/template/arcade/arcade_play_body.html',
			'styles/prosilver/template/arcade/arcade_score_body.html',
			'styles/prosilver/template/arcade/arcade_stats_body.html',
			'styles/prosilver/template/arcade/arcade_version_body.html',
			'styles/subsilver2/template/ucp_arcade_settings.html',
			'styles/subsilver2/template/ucp_arcade_favorites.html',
			'styles/subsilver2/template/arcade/arcade_breadcrumbs.html',
			'styles/subsilver2/template/arcade/arcade_download_body.html',
			'styles/subsilver2/template/arcade/arcade_header_body.html',
			'styles/subsilver2/template/arcade/arcade_index_body.html',
			'styles/subsilver2/template/arcade/arcade_jumpbox.html',
			'styles/subsilver2/template/arcade/arcade_list_body.html',
			'styles/subsilver2/template/arcade/arcade_login_cat.html',
			'styles/subsilver2/template/arcade/arcade_online_body.html',
			'styles/subsilver2/template/arcade/arcade_play_body.html',
			'styles/subsilver2/template/arcade/arcade_score_body.html',
			'styles/subsilver2/template/arcade/arcade_stats_body.html',
			'styles/subsilver2/template/arcade/arcade_version_body.html',
			'styles/subsilver2/theme/images/icon_mini_arcade.gif',
		);

		$this->arcade_edits['index.php'] = array(
			'require($phpbb_root_path . \'includes/arcade/scoretype/ibpro.\'.$phpEx);',
			'require($phpbb_root_path . \'includes/arcade/scoretype/ibprov3.\'.$phpEx);',
		);

		$this->arcade_edits['viewonline.php'] = array(
			'case \'arcade\':',
			'include($phpbb_root_path . \'includes/arcade/arcade_common.\' . $phpEx);',
		);
		
		$this->arcade_edits['includes/auth.php'] = array(
			'global $phpbb_root_path, $table_prefix, $phpEx;',
			'include_once($phpbb_root_path . \'includes/arcade/arcade_constants.\' . $phpEx);',
			'include_once($phpbb_root_path . \'includes/auth_arcade.\' . $phpEx);',
		);

		$this->arcade_edits['includes/functions.php'] = array(
			'global $arcade;',
			'$user->add_lang(\'mods/arcade\');',
			'$template->assign_var(\'U_ARCADE\', append_sid("{$phpbb_root_path}arcade.$phpEx"));',
		);

		$this->arcade_edits['includes/functions_user.php'] = array(
			'if (!class_exists(\'arcade_admin\'))',
			'include($phpbb_root_path . \'includes/arcade/arcade_common.\' . $phpEx);',
			'global $arcade, $auth_arcade, $table_prefix;',
			'if (!isset($arcade))',
			'$arcade = new arcade_admin();',
			'$arcade->delete_user($user_id, $user_row[\'username\']);',
			'\'user_arcade_permissions\'',
			'WHERE " . $db->sql_in_set(\'cat_last_play_user_id\', $user_id_ary);',
		);

		$this->arcade_edits['viewtopic.php'] = array(
			'include($phpbb_root_path . \'includes/arcade/functions_arcade.\' . $phpEx);',
			'$user->add_lang(\'mods/arcade\');',
			'$postrow = array_merge($postrow, $arcade_data);',
		);

		$this->arcade_edits['memberlist.php'] = array(
			'include($phpbb_root_path . \'includes/arcade/functions_arcade.\' . $phpEx);',
			'$user->add_lang(\'mods/arcade\');',
			'$template->assign_vars($arcade_data);',
		);
		
		$this->arcade_edits['ucp.php'] = array(
			'include($phpbb_root_path . \'includes/arcade/arcade_constants.\' . $phpEx);',
			'include($phpbb_root_path . \'includes/auth_arcade.\' . $phpEx);',
			'include($phpbb_root_path . \'includes/acp/auth_arcade.\' . $phpEx);',
			'$auth_arcade_admin = new auth_arcade_admin();',
			'if (!$auth_arcade_admin->ghost_permissions($user_id, $user->data[\'user_id\']))',
		);

		$this->arcade_edits['styles/prosilver/template/overall_header.html'] = array(
			'<li class="icon-home"><a href="{U_INDEX}" accesskey="h">{L_INDEX}</a> <strong>&#8249;</strong> <a href="{U_ARCADE}">{L_ARCADE_INDEX}</a><!-- IF S_IN_SEARCH --> <strong>&#8249;</strong> {L_ARCADE_SEARCH}<!-- ENDIF -->',
			'<li class="icon-ucp"><a href="{U_ARCADE}" title="{L_ARCADE_EXPLAIN}">{L_ARCADE}</a></li>',
			'<!-- IF S_IN_ARCADE and S_ARCADE_DISABLED and S_USER_LOGGED_IN and U_ACP -->',
		);

		$this->arcade_edits['styles/prosilver/template/viewtopic_body.html'] = array(
			'<!-- IF postrow.S_HAS_HIGHSCORES --><dd><strong>{L_ARCADE_HIGHSCORES}:</strong> <a href="{postrow.U_ARCADE_STATS}">{postrow.TOTAL_HIGHSCORES}</a></dd><!-- ENDIF -->',
		);

		$this->arcade_edits['styles/prosilver/template/memberlist_view.html'] = array(
			'<!-- IF S_HAS_HIGHSCORES --><dt>{L_ARCADE_HIGHSCORES}:</dt> <dd>{TOTAL_HIGHSCORES} | <strong><a href="{U_ARCADE_STATS}">{L_ARCADE_VIEW_USERS_STATS}</a></strong></dd><!-- ENDIF -->',
		);

		$this->arcade_edits['styles/subsilver2/template/overall_header.html'] = array(
			'<!-- INCLUDE arcade/arcade_breadcrumbs.html -->',
			'<a href="{U_ARCADE}"><img src="{T_THEME_PATH}/images/icon_mini_arcade.gif" width="12" height="13" alt="*" />',
			'<!-- IF S_IN_ARCADE and S_ARCADE_DISABLED and S_USER_LOGGED_IN --> &nbsp;<span style="color: red;">{L_ARCADE_DISABLED}</span><!-- ENDIF -->',
		);

		$this->arcade_edits['styles/subsilver2/template/viewtopic_body.html'] = array(
			'<!-- IF postrow.S_HAS_HIGHSCORES --><br /><b>{L_ARCADE_HIGHSCORES}:</b> <a href="{postrow.U_ARCADE_STATS}">{postrow.TOTAL_HIGHSCORES}</a><!-- ENDIF -->',
		);

		$this->arcade_edits['styles/subsilver2/template/memberlist_view.html'] = array(
			'<td><b class="gen">{TOTAL_HIGHSCORES}</b><span class="genmed"><br /><a href="{U_ARCADE_STATS}">{L_ARCADE_VIEW_USERS_STATS}</a></span></td>',
		);

		$this->arcade_permissions = array(
			'c_',
			'c_list',
			'c_view',
			'c_play',
			'c_popup',
			'c_score',
			'c_rate',
			'c_comment',
			'c_download',
			'c_ignorecontrol',
			'c_resolution',
		);

		$this->phpbb_permissions = array(
			'a_cauth',
			'a_arcade_settings',
			'a_arcade_game',
			'a_arcade_delete_game',
			'a_arcade_cat',
			'a_arcade_delete_cat',
			'a_arcade_scores',
			'a_arcade_utilities',
		);

		$this->arcade_modules['acp'] = array(
			'arcade_utilities' 			=> array('downloads', 'errors', 'convert_install', 'create_install', 'download_stats'),
			'arcade_games'				=> array('edit_games', 'add_games', 'unpack_games'),
			'arcade'					=> array('settings'),
			'arcade_manage'				=> array('manage'),
			'arcade_permission_roles'	=> array('cat_roles'),
			'arcade_permissions'		=> array('trace', 'setting_category_local', 'setting_user_local', 'setting_group_local'),
		);

		$this->arcade_modules['ucp'] = array(
			'arcade' => array('settings', 'favorites'),
		);

		$this->arcade_alter_db = array(
			USERS_TABLE		=> array('user_arcade_permissions', 'user_arcade_perm_from', 'user_arcade_pm', 'games_per_page', 'games_sort_dir', 'games_sort_order'),
		);

	}

	function check_tables()
	{
		global $db, $table_prefix;

		echo '<h3>Checking if database tables exist...</h3>';
		$error = array();
		$tables = get_tables($db);
		foreach ($this->arcade_tables as $table_name)
		{
			if (!in_array($table_name, $tables))
			{
				$error[] = $table_name;
			}
		}
		unset($tables);

		if (sizeof($error))
		{
			$this->no_errors = false;
			$this->display_error('The following tables were not found:', $error);
		}
		else
		{
			$this->display_success('All tables found');
		}
	}

	function check_alter_db()
	{
		global $phpbb_root_path, $db;

		$db->sql_return_on_error(true);

		echo '<h3>Checking other database data...</h3>';
		$error = array();
		foreach ($this->arcade_alter_db as $key => $value)
		{
			$table = $key;
			foreach ($value as $column)
			{
				$sql = 'SELECT ' . $column . '
					FROM ' . $table;
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if ($db->sql_error_triggered)
				{
					$db->sql_error_triggered = false;
					$error[] = $column;
				}
				unset($row);
			}

			if (sizeof($error))
			{
				$this->no_errors = false;
				$this->display_error('The following columns are missing from the ' . $table . ' table:', $error);
			}
			else
			{
				$this->display_success($table . ' table correctly altered');
			}
			unset($error);
		}

		$db->sql_return_on_error(false);
	}

	function check_files()
	{
		global $phpbb_root_path;

		echo '<h3>Checking if files exist...</h3>';
		$error = array();
		foreach($this->arcade_files as $file)
		{
			if (!file_exists($phpbb_root_path . $file))
			{
				$error[] = 'phpbb_root_path/' . $file;
			}
		}

		if (sizeof($error))
		{
			$this->no_errors = false;
			$this->display_error('The following files were not found:', $error);
		}
		else
		{
			$this->display_success('All files found');
		}
	}

	function check_edits()
	{
		global $phpbb_root_path;

		echo '<h3>Checking file edits...</h3>';
		$error = array();
		foreach($this->arcade_edits as $key => $value)
		{
			$content = file_get_contents($phpbb_root_path . $key);
			foreach ($value as $edit)
			{	
				if (strpos($content, $edit) === false)
				{
					$error[] = 'phpbb_root_path/' . $key . ' - <span style="color: black;">' . htmlspecialchars($edit) . '</span>';
					break;
				}
			}
		}

		if (sizeof($error))
		{
			$this->no_errors = false;
			$this->display_error('The following files do not seem to be edited:', $error);
		}
		else
		{
			$this->display_success('All files edited');
		}
	}

	function check_modules()
	{
		global $phpbb_root_path, $db;

		echo '<h3>Checking modules...</h3>';
		$error = array();

		foreach($this->arcade_modules['acp'] as $key => $value)
		{
			$module_basename = $key;
			foreach ($value as $module_mode)
			{
				$sql = 'SELECT parent_id
					FROM ' . MODULES_TABLE . "
					WHERE module_basename = '$module_basename'
						AND module_class = 'acp'
						AND module_mode = '$module_mode'";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					$error[] = 'ACP Module: module_basename = ' . $module_basename . ', module_mode = ' . $module_mode;
				}
				unset($row);
			}
		}

		foreach($this->arcade_modules['ucp'] as $key => $value)
		{
			$module_basename = $key;
			foreach ($value as $module_mode)
			{
				$sql = 'SELECT parent_id
					FROM ' . MODULES_TABLE . "
					WHERE module_basename = '$module_basename'
						AND module_class = 'ucp'
						AND module_mode = '$module_mode'";
				$result = $db->sql_query($sql);
				$row = $db->sql_fetchrow($result);
				$db->sql_freeresult($result);

				if (!$row)
				{
					$error[] = 'UCP Module: module_basename = ' . $module_basename . ', module_mode = ' . $module_mode;
				}
				unset($row);
			}
		}

		if (sizeof($error))
		{
			$this->no_errors = false;
			$this->display_error('The following modules do not seem to be installed:', $error);
		}
		else
		{
			$this->display_success('All modules installed');
		}
	}

	function check_permissions()
	{
		global $phpbb_root_path, $db;

		$db->sql_return_on_error(true);
		
		echo '<h3>Checking permissions data...</h3>';
		$error = array();
		foreach ($this->phpbb_permissions as $value)
		{
			$sql = 'SELECT auth_option_id
				FROM ' . ACL_OPTIONS_TABLE . "
				WHERE auth_option = '$value'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if (!$row)
			{
				$error[] = $value;
			}
			unset($row);
		}

		foreach ($this->arcade_permissions as $value)
		{
			$sql = 'SELECT auth_option_id
				FROM ' . ACL_ARCADE_OPTIONS_TABLE . "
				WHERE auth_option = '$value'";
			$result = $db->sql_query($sql);
			$row = $db->sql_fetchrow($result);
			$db->sql_freeresult($result);

			if (!$row || $db->sql_error_triggered)
			{
				$db->sql_error_triggered = false;
				$error[] = $value;
			}
			unset($row);
		}

		if (sizeof($error))
		{
			$this->no_errors = false;
			$this->display_error('The following permissions do not exist:', $error);
		}
		else
		{
			$this->display_success('All permissions exist');
		}
		
		$tables = array(ACL_OPTIONS_TABLE, ACL_ARCADE_OPTIONS_TABLE);
		foreach ($tables as $table)
		{		
			$sql = 'SELECT auth_option_id, auth_option
				FROM ' . $table . '
				ORDER BY auth_option_id';
			$result = $db->sql_query($sql);
			$auth_option_id = array();
			while ($row = $db->sql_fetchrow($result))
			{
				$auth_option_id[$row['auth_option_id']] = $row['auth_option'];
			}
			$db->sql_freeresult($result);

			$duplicate_auth = array_count_values($auth_option_id);
			unset($auth_option_id);

			$auth_option_id = array();
			foreach ($duplicate_auth as $key => $value)
			{
				if ($value > 1)
				{
					$auth_option_id[] = $key . ' was found ' . $value . ' times';
				}
			}

			if (!empty($auth_option_id))
			{
				$this->no_errors = false;
				$this->display_error('Duplicate auth values can cause problems with permissions. The following duplicate auth values were found inside the ' . $table . ':', $auth_option_id);
			}
		}
		
		$db->sql_return_on_error(false);
	}

	function display_success($text)
	{
		echo '<p style="color: green;"><b>' . $text . '</b></p>';
	}

	function display_error($title, $error)
	{
		echo '<p style="color: red; font-size: 1.05em; font-family: \'Trebuchet MS\', Helvetica, sans-serif;"><strong>'. $title .'</strong><br />' . implode('<br />', $error) . '</p>';
	}

	function display_done()
	{
		if ($this->no_errors)
		{
			echo '<h2 style="color: green;">There were no errors found with the installation.</h2>';
		}
		else
		{
			echo '<h2 style="color: red;">There were errors found with the installation.</h2>';
		}
	}

	function install_header($title, $mod, $dir = '', $lang = '')
	{
		global $phpbb_root_path, $table_prefix, $db;

	header('Content-type: text/html; charset=UTF-8');
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml" dir="' . $dir . '" lang="' . $lang . '" xml:lang="' . $lang . '">
	<head>

	<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
	<meta http-equiv="content-language" content="' . $lang . '" />
	<meta http-equiv="content-style-type" content="text/css" />
	<meta http-equiv="imagetoolbar" content="no" />

	<style type="text/css" media="screen">
		blockquote {
			background: #ebebeb none 6px 8px no-repeat;
			border: 1px solid #dbdbdb;
			font-size: 0.95em;
			margin: 0.5em 1px 0 25px;
			overflow: hidden;
			padding: 5px;
			background-color: #EBEADD;
			border-color:#DBDBCE;
		}
	</style>

	<title>' . $title . '</title>

	<link href="' . $phpbb_root_path . 'adm/style/admin.css" rel="stylesheet" type="text/css" media="screen" />

	<script type="text/javascript">
	<!--
	function togglemenu(id)
	{
		if (document.getElementById(id))
		{
			if (document.getElementById(id).style.display == \'none\')
			{
				document.getElementById(id).style.display = \'inline\';
			}
			else
			{
				document.getElementById(id).style.display = \'none\';
			}
		}
	}
	-->
	</script>

	</head>

	<body>
	<div id="wrap">
		<div id="page-header">
		<h1>Installation Panel</h1>
		</div>

		<div id="page-body">
			<div id="acp">
			<div class="panel">
				<span class="corners-top"><span></span></span>
					<div id="content">
						<div id="main"><h1>' . $title . '</h1>								
								<p>Table Prefix :: ' . $table_prefix . '<br />
								Database Type :: ' . $db->sql_layer . '</p>
								<p>This script will check the installation of the ' . $mod . ' for errors.<br />Click <a href="./install.php">here</a> to install/uninstall/update the ' . $mod . '.</p>';
	}

	function install_footer()
	{

						echo '<p>Click <a href="./../index.php">here</a> to return to the board index.</p></div>
					</div>
				<span class="corners-bottom"><span></span></span>
			</div>
			</div>
		</div>

		<div id="page-footer">
			Powered by phpBB Arcade &copy; 2008 <a href="http:// www.jeffrusso.net">JRSweets</a><br />
			Powered by phpBB &copy; 2000, 2002, 2005, 2007 <a href="http:// www.phpbb.com/">phpBB Group</a>

		</div>
	</div>

	</body>
	</html>';

		garbage_collection();
	}
}

?>
