#
# $Id: $
#


# Table: 'phpbb_acl_arcade_groups'
CREATE TABLE phpbb_acl_arcade_groups (
	group_id INTEGER DEFAULT 0 NOT NULL,
	cat_id INTEGER DEFAULT 0 NOT NULL,
	auth_option_id INTEGER DEFAULT 0 NOT NULL,
	auth_role_id INTEGER DEFAULT 0 NOT NULL,
	auth_setting INTEGER DEFAULT 0 NOT NULL
);;

CREATE INDEX phpbb_acl_arcade_groups_group_id ON phpbb_acl_arcade_groups(group_id);;
CREATE INDEX phpbb_acl_arcade_groups_auth_opt_id ON phpbb_acl_arcade_groups(auth_option_id);;
CREATE INDEX phpbb_acl_arcade_groups_auth_role_id ON phpbb_acl_arcade_groups(auth_role_id);;

# Table: 'phpbb_acl_arcade_options'
CREATE TABLE phpbb_acl_arcade_options (
	auth_option_id INTEGER NOT NULL,
	auth_option VARCHAR(50) CHARACTER SET NONE DEFAULT '' NOT NULL,
	is_global INTEGER DEFAULT 0 NOT NULL,
	is_local INTEGER DEFAULT 0 NOT NULL,
	founder_only INTEGER DEFAULT 0 NOT NULL
);;

ALTER TABLE phpbb_acl_arcade_options ADD PRIMARY KEY (auth_option_id);;

CREATE INDEX phpbb_acl_arcade_options_auth_option ON phpbb_acl_arcade_options(auth_option);;

CREATE GENERATOR phpbb_acl_arcade_options_gen;;
SET GENERATOR phpbb_acl_arcade_options_gen TO 0;;

CREATE TRIGGER t_phpbb_acl_arcade_options FOR phpbb_acl_arcade_options
BEFORE INSERT
AS
BEGIN
	NEW.auth_option_id = GEN_ID(phpbb_acl_arcade_options_gen, 1);
END;;


# Table: 'phpbb_acl_arcade_roles'
CREATE TABLE phpbb_acl_arcade_roles (
	role_id INTEGER NOT NULL,
	role_name VARCHAR(255) CHARACTER SET UTF8 DEFAULT '' NOT NULL COLLATE UNICODE,
	role_description BLOB SUB_TYPE TEXT CHARACTER SET UTF8 DEFAULT '' NOT NULL,
	role_type VARCHAR(10) CHARACTER SET NONE DEFAULT '' NOT NULL,
	role_order INTEGER DEFAULT 0 NOT NULL
);;

ALTER TABLE phpbb_acl_arcade_roles ADD PRIMARY KEY (role_id);;

CREATE INDEX phpbb_acl_arcade_roles_role_type ON phpbb_acl_arcade_roles(role_type);;
CREATE INDEX phpbb_acl_arcade_roles_role_order ON phpbb_acl_arcade_roles(role_order);;

CREATE GENERATOR phpbb_acl_arcade_roles_gen;;
SET GENERATOR phpbb_acl_arcade_roles_gen TO 0;;

CREATE TRIGGER t_phpbb_acl_arcade_roles FOR phpbb_acl_arcade_roles
BEFORE INSERT
AS
BEGIN
	NEW.role_id = GEN_ID(phpbb_acl_arcade_roles_gen, 1);
END;;


# Table: 'phpbb_acl_arcade_roles_data'
CREATE TABLE phpbb_acl_arcade_roles_data (
	role_id INTEGER DEFAULT 0 NOT NULL,
	auth_option_id INTEGER DEFAULT 0 NOT NULL,
	auth_setting INTEGER DEFAULT 0 NOT NULL
);;

ALTER TABLE phpbb_acl_arcade_roles_data ADD PRIMARY KEY (role_id, auth_option_id);;

CREATE INDEX phpbb_acl_arcade_roles_data_ath_op_id ON phpbb_acl_arcade_roles_data(auth_option_id);;

# Table: 'phpbb_acl_arcade_users'
CREATE TABLE phpbb_acl_arcade_users (
	user_id INTEGER DEFAULT 0 NOT NULL,
	cat_id INTEGER DEFAULT 0 NOT NULL,
	auth_option_id INTEGER DEFAULT 0 NOT NULL,
	auth_role_id INTEGER DEFAULT 0 NOT NULL,
	auth_setting INTEGER DEFAULT 0 NOT NULL
);;

CREATE INDEX phpbb_acl_arcade_users_user_id ON phpbb_acl_arcade_users(user_id);;
CREATE INDEX phpbb_acl_arcade_users_auth_option_id ON phpbb_acl_arcade_users(auth_option_id);;
CREATE INDEX phpbb_acl_arcade_users_auth_role_id ON phpbb_acl_arcade_users(auth_role_id);;

