/*

 $Id: $

*/

BEGIN TRANSACTION
GO

/*
	Table: 'phpbb_acl_arcade_groups'
*/
CREATE TABLE [phpbb_acl_arcade_groups] (
	[group_id] [int] DEFAULT (0) NOT NULL ,
	[cat_id] [int] DEFAULT (0) NOT NULL ,
	[auth_option_id] [int] DEFAULT (0) NOT NULL ,
	[auth_role_id] [int] DEFAULT (0) NOT NULL ,
	[auth_setting] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

CREATE  INDEX [group_id] ON [phpbb_acl_arcade_groups]([group_id]) ON [PRIMARY]
GO

CREATE  INDEX [auth_opt_id] ON [phpbb_acl_arcade_groups]([auth_option_id]) ON [PRIMARY]
GO

CREATE  INDEX [auth_role_id] ON [phpbb_acl_arcade_groups]([auth_role_id]) ON [PRIMARY]
GO


/*
	Table: 'phpbb_acl_arcade_options'
*/
CREATE TABLE [phpbb_acl_arcade_options] (
	[auth_option_id] [int] IDENTITY (1, 1) NOT NULL ,
	[auth_option] [varchar] (50) DEFAULT ('') NOT NULL ,
	[is_global] [int] DEFAULT (0) NOT NULL ,
	[is_local] [int] DEFAULT (0) NOT NULL ,
	[founder_only] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_acl_arcade_options] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_acl_arcade_options] PRIMARY KEY  CLUSTERED 
	(
		[auth_option_id]
	)  ON [PRIMARY] 
GO

CREATE  INDEX [auth_option] ON [phpbb_acl_arcade_options]([auth_option]) ON [PRIMARY]
GO


/*
	Table: 'phpbb_acl_arcade_roles'
*/
CREATE TABLE [phpbb_acl_arcade_roles] (
	[role_id] [int] IDENTITY (1, 1) NOT NULL ,
	[role_name] [varchar] (255) DEFAULT ('') NOT NULL ,
	[role_description] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[role_type] [varchar] (10) DEFAULT ('') NOT NULL ,
	[role_order] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_acl_arcade_roles] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_acl_arcade_roles] PRIMARY KEY  CLUSTERED 
	(
		[role_id]
	)  ON [PRIMARY] 
GO

CREATE  INDEX [role_type] ON [phpbb_acl_arcade_roles]([role_type]) ON [PRIMARY]
GO

CREATE  INDEX [role_order] ON [phpbb_acl_arcade_roles]([role_order]) ON [PRIMARY]
GO


/*
	Table: 'phpbb_acl_arcade_roles_data'
*/
CREATE TABLE [phpbb_acl_arcade_roles_data] (
	[role_id] [int] DEFAULT (0) NOT NULL ,
	[auth_option_id] [int] DEFAULT (0) NOT NULL ,
	[auth_setting] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_acl_arcade_roles_data] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_acl_arcade_roles_data] PRIMARY KEY  CLUSTERED 
	(
		[role_id],
		[auth_option_id]
	)  ON [PRIMARY] 
GO

CREATE  INDEX [ath_op_id] ON [phpbb_acl_arcade_roles_data]([auth_option_id]) ON [PRIMARY]
GO


/*
	Table: 'phpbb_acl_arcade_users'
*/
CREATE TABLE [phpbb_acl_arcade_users] (
	[user_id] [int] DEFAULT (0) NOT NULL ,
	[cat_id] [int] DEFAULT (0) NOT NULL ,
	[auth_option_id] [int] DEFAULT (0) NOT NULL ,
	[auth_role_id] [int] DEFAULT (0) NOT NULL ,
	[auth_setting] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

CREATE  INDEX [user_id] ON [phpbb_acl_arcade_users]([user_id]) ON [PRIMARY]
GO

CREATE  INDEX [auth_option_id] ON [phpbb_acl_arcade_users]([auth_option_id]) ON [PRIMARY]
GO

CREATE  INDEX [auth_role_id] ON [phpbb_acl_arcade_users]([auth_role_id]) ON [PRIMARY]
GO



COMMIT
GO

