#
# $Id: $
#

# Table: 'phpbb_acl_arcade_groups'
CREATE TABLE phpbb_acl_arcade_groups (
	group_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_option_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_role_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_setting tinyint(2) DEFAULT '0' NOT NULL,
	KEY group_id (group_id),
	KEY auth_opt_id (auth_option_id),
	KEY auth_role_id (auth_role_id)
);


# Table: 'phpbb_acl_arcade_options'
CREATE TABLE phpbb_acl_arcade_options (
	auth_option_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	auth_option varbinary(50) DEFAULT '' NOT NULL,
	is_global tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	is_local tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	founder_only tinyint(1) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (auth_option_id),
	KEY auth_option (auth_option)
);


# Table: 'phpbb_acl_arcade_roles'
CREATE TABLE phpbb_acl_arcade_roles (
	role_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	role_name blob NOT NULL,
	role_description blob NOT NULL,
	role_type varbinary(10) DEFAULT '' NOT NULL,
	role_order smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (role_id),
	KEY role_type (role_type),
	KEY role_order (role_order)
);


# Table: 'phpbb_acl_arcade_roles_data'
CREATE TABLE phpbb_acl_arcade_roles_data (
	role_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_option_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_setting tinyint(2) DEFAULT '0' NOT NULL,
	PRIMARY KEY (role_id, auth_option_id),
	KEY ath_op_id (auth_option_id)
);


# Table: 'phpbb_acl_arcade_users'
CREATE TABLE phpbb_acl_arcade_users (
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_option_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_role_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	auth_setting tinyint(2) DEFAULT '0' NOT NULL,
	KEY user_id (user_id),
	KEY auth_option_id (auth_option_id),
	KEY auth_role_id (auth_role_id)
);


# Table: 'phpbb_arcade_access'
CREATE TABLE phpbb_arcade_access (
	cat_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	session_id binary(32) DEFAULT '' NOT NULL,
	PRIMARY KEY (cat_id, user_id, session_id)
);


# Table: 'phpbb_arcade_categories'
CREATE TABLE phpbb_arcade_categories (
	cat_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	parent_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	left_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	right_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_parents mediumblob NOT NULL,
	cat_name blob NOT NULL,
	cat_desc blob NOT NULL,
	cat_desc_bitfield varbinary(255) DEFAULT '' NOT NULL,
	cat_desc_options int(11) UNSIGNED DEFAULT '7' NOT NULL,
	cat_desc_uid varbinary(8) DEFAULT '' NOT NULL,
	cat_link blob NOT NULL,
	cat_password varbinary(120) DEFAULT '' NOT NULL,
	cat_style smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	cat_display smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	cat_image varbinary(255) DEFAULT '' NOT NULL,
	cat_rules blob NOT NULL,
	cat_rules_link blob NOT NULL,
	cat_rules_bitfield varbinary(255) DEFAULT '' NOT NULL,
	cat_rules_options int(11) UNSIGNED DEFAULT '7' NOT NULL,
	cat_rules_uid varbinary(8) DEFAULT '' NOT NULL,
	cat_games_per_page tinyint(4) DEFAULT '0' NOT NULL,
	cat_type tinyint(4) DEFAULT '0' NOT NULL,
	cat_status tinyint(4) DEFAULT '0' NOT NULL,
	cat_games mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_plays mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_download tinyint(1) DEFAULT '1' NOT NULL,
	cat_last_play_game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_last_play_game_name varbinary(255) DEFAULT '0' NOT NULL,
	cat_last_play_user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	cat_last_play_score decimal(25,3) DEFAULT '0' NOT NULL,
	cat_last_play_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
	cat_last_game_installdate int(11) UNSIGNED DEFAULT '0' NOT NULL,
	cat_last_play_username blob NOT NULL,
	cat_last_play_user_colour varbinary(6) DEFAULT '' NOT NULL,
	cat_flags tinyint(4) DEFAULT '32' NOT NULL,
	display_subcat_list tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
	display_on_index tinyint(1) UNSIGNED DEFAULT '1' NOT NULL,
	PRIMARY KEY (cat_id),
	KEY left_right_id (left_id, right_id),
	KEY cat_lastplay_game_id (cat_last_play_game_id)
);


# Table: 'phpbb_arcade_config'
CREATE TABLE phpbb_arcade_config (
	config_name varbinary(255) DEFAULT '' NOT NULL,
	config_value blob NOT NULL,
	PRIMARY KEY (config_name)
);


# Table: 'phpbb_arcade_errors'
CREATE TABLE phpbb_arcade_errors (
	error_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	score decimal(25,3) DEFAULT '0' NOT NULL,
	error_date int(11) UNSIGNED DEFAULT '0' NOT NULL,
	error_type tinyint(1) DEFAULT '0' NOT NULL,
	game_type tinyint(1) DEFAULT '0' NOT NULL,
	submitted_game_type tinyint(1) DEFAULT '0' NOT NULL,
	played_time int(11) DEFAULT '0' NOT NULL,
	error_ip varbinary(40) DEFAULT '' NOT NULL,
	PRIMARY KEY (error_id)
);


# Table: 'phpbb_arcade_favorites'
CREATE TABLE phpbb_arcade_favorites (
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (user_id, game_id)
);


# Table: 'phpbb_arcade_games'
CREATE TABLE phpbb_arcade_games (
	game_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	game_image varbinary(255) DEFAULT '' NOT NULL,
	game_desc blob NOT NULL,
	game_highscore decimal(25,3) DEFAULT '0' NOT NULL,
	game_highdate int(11) UNSIGNED DEFAULT '0' NOT NULL,
	game_highuser mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_files mediumblob NOT NULL,
	game_name varbinary(255) DEFAULT '' NOT NULL,
	game_name_clean varbinary(255) DEFAULT '' NOT NULL,
	game_swf varbinary(255) DEFAULT '' NOT NULL,
	game_scorevar varbinary(255) DEFAULT '' NOT NULL,
	game_type tinyint(1) DEFAULT '0' NOT NULL,
	game_width int(5) UNSIGNED DEFAULT '550' NOT NULL,
	game_height int(5) UNSIGNED DEFAULT '380' NOT NULL,
	game_installdate int(11) UNSIGNED DEFAULT '0' NOT NULL,
	game_filesize int(20) UNSIGNED DEFAULT '0' NOT NULL,
	game_scoretype tinyint(1) DEFAULT '0' NOT NULL,
	game_order mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_plays mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_votetotal mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_votesum mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_download_total mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_download tinyint(1) DEFAULT '1' NOT NULL,
	cat_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (game_id)
);


# Table: 'phpbb_arcade_game_rating'
CREATE TABLE phpbb_arcade_game_rating (
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_rating mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	rating_date int(11) UNSIGNED DEFAULT '0' NOT NULL,
	user_ip varbinary(40) DEFAULT '' NOT NULL,
	PRIMARY KEY (game_id, user_id)
);


# Table: 'phpbb_arcade_scores'
CREATE TABLE phpbb_arcade_scores (
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	score decimal(25,3) DEFAULT '0' NOT NULL,
	comment_text mediumblob NOT NULL,
	comment_bitfield varbinary(255) DEFAULT '' NOT NULL,
	comment_options int(11) UNSIGNED DEFAULT '7' NOT NULL,
	comment_uid varbinary(8) DEFAULT '' NOT NULL,
	score_date int(11) UNSIGNED DEFAULT '0' NOT NULL,
	total_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
	total_plays mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (game_id, user_id)
);


# Table: 'phpbb_arcade_sessions'
CREATE TABLE phpbb_arcade_sessions (
	session_id binary(32) DEFAULT '' NOT NULL,
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_type tinyint(1) DEFAULT '0' NOT NULL,
	randchar1 varbinary(30) DEFAULT '' NOT NULL,
	randchar2 varbinary(30) DEFAULT '' NOT NULL,
	randgid1 varbinary(30) DEFAULT '' NOT NULL,
	randgid2 varbinary(30) DEFAULT '' NOT NULL,
	start_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (session_id)
);


# Table: 'phpbb_arcade_download'
CREATE TABLE phpbb_arcade_download (
	user_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	game_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	total mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	download_time int(11) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (user_id, game_id)
);


