<?php
/**
*
* @package acp
* @version $Id: acp_arcade.php 328 2008-07-08 01:05:15Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_arcade
{
	var $u_action;
	var $new_config = array();

	function main($id, $mode)
	{
		global $db, $user, $auth, $auth_arcade, $template, $cache, $table_prefix, $arcade;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		include($phpbb_root_path . 'includes/arcade/arcade_common.' . $phpEx);
		// Initialize arcade auth
		$auth_arcade->acl($user->data);
		// Initialize arcade class
		$arcade = new arcade_admin();

		$this->tpl_name = 'acp_arcade';
		$version_check = (isset($_POST['version_check'])) ? true : false;
		if ($version_check)
		{
			$mode =  'version';
		}

		switch ($mode)
		{
			case 'settings':
				$this->manage_settings();
			break;

			case 'version':
				$this->manage_version_check();
			break;

			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}
	}

	function manage_settings()
	{
		global $db, $user, $auth, $auth_arcade, $template, $cache, $table_prefix, $arcade;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx, $mode;

		$form_key = 'acp_arcade';
		add_form_key($form_key);

		$update		= (isset($_POST['update'])) ? true : false;
		$template->assign_var('S_ARCADE_SETTINGS', true);

		$display_vars = array(
			'title'			=> 'ACP_ARCADE_SETTINGS',
			'title_explain'	=> 'ACP_ARCADE_SETTINGS_EXPLAIN',
			'vars'	=> array(
				'legend1'				=> 'ACP_ARCADE_VERSION_INFO',
				'version'				=> array('lang' => 'ARCADE_VERSION', 	'validate' => 'string', 'type' => 'custom', 'method' => 'arcade_version', 'explain' => true),

				'legend2'				=> 'ACP_ARCADE_SETTINGS_PATH',
				'game_path'				=> array('lang' => 'ARCADE_GAME_PATH',	'validate' => 'path', 'type' => 'text:30:65', 'explain' => true),
				'unpack_game_path'		=> array('lang' => 'ARCADE_UNPACK_GAME_PATH',	'validate' => 'path', 'type' => 'text:30:65', 'explain' => true),
				'image_path'			=> array('lang' => 'ARCADE_IMAGE_PATH',	'validate' => 'path', 'type' => 'text:30:65', 'explain' => true),
				'cat_image_path'		=> array('lang' => 'ARCADE_CAT_IMAGE_PATH',	'validate' => 'path', 'type' => 'text:30:65', 'explain' => true),

				'legend3'				=> 'ACP_ARCADE_SETTINGS_GENERAL',
				'arcade_disable'		=> array('lang' => 'DISABLE_ARCADE',			'validate' => 'bool',	'type' => 'custom', 'method' => 'arcade_disable', 'explain' => true),
				'arcade_disable_msg'	=> false,
				'games_sort_order'		=> array('lang' => 'ARCADE_GAMES_SORT_ORDER',  'validate' => 'string', 'type' => 'select', 'method' => 'games_sort_order_select', 'explain' => true),
				'games_sort_dir'		=> array('lang' => 'ARCADE_GAMES_SORT_DIR',  'validate' => 'string', 'type' => 'select', 'method' => 'games_sort_dir_select', 'explain' => true),
				'games_per_page'		=> array('lang' => 'ARCADE_GAMES_PER_PAGE',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'download_list'			=> array('lang' => 'ARCADE_DOWNLOAD_LIST', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'new_games_delay'		=> array('lang' => 'ARCADE_NEW_GAMES_DELAY',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'flash_version'			=> array('lang' => 'ARCADE_ACP_FLASH_VERSION',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'resolution_select'		=> array('lang' => 'ARCADE_RESOLUTION_SELECT', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'display_desc'			=> array('lang' => 'ARCADE_DISPLAY_DESC', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'parse_bbcode'			=> array('lang' => 'ARCADE_COMMENTS_BBCODE', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'parse_smilies'			=> array('lang' => 'ARCADE_COMMENTS_SMILIES', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'parse_links'			=> array('lang' => 'ARCADE_COMMENTS_LINKS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'played_games'			=> array('lang' => 'ARCADE_PLAYED_GAMES', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'played_colour'			=> array('lang' => 'ARCADE_PLAYED_GAMES_COLOUR',	'validate' => 'string', 'type' => 'text:7:6', 'explain' => true),
				'cache_time'			=> array('lang' => 'ARCADE_CACHE_TIME',		'validate' => 'int',	'type' => 'text:4:3', 'explain' => true, 'append' => ' ' . $user->lang['HOURS']),
				'online_time'			=> array('lang' => 'ARCADE_ONLINE_TIME',		'validate' => 'int',	'type' => 'text:4:3', 'explain' => true, 'append' => ' ' . $user->lang['MINUTES']),

				'legend4'				=> 'ACP_ARCADE_SETTINGS_GLOBAL_GAME',
				'game_width'			=> array('lang' => 'ARCADE_GLOBAL_GAME_WIDTH',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'game_height'			=> array('lang' => 'ARCADE_GLOBAL_GAME_HEIGHT',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),

				'legend5'				=> 'ACP_ARCADE_SETTINGS_PAGE',
				'display_viewtopic'		=> array('lang' => 'ARCADE_DISPLAY_VIEWTOPIC', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'display_memberlist'	=> array('lang' => 'ARCADE_DISPLAY_MEMBERLIST', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'welcome_index'			=> array('lang' => 'ARCADE_WELCOME_INDEX', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'search_index'			=> array('lang' => 'ARCADE_SEARCH_INDEX', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'links_index'			=> array('lang' => 'ARCADE_LINKS_INDEX', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'welcome_cats'			=> array('lang' => 'ARCADE_WELCOME_CATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'search_cats'			=> array('lang' => 'ARCADE_SEARCH_CATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'links_cats'			=> array('lang' => 'ARCADE_LINKS_CATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'welcome_stats'			=> array('lang' => 'ARCADE_WELCOME_STATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),				
				'search_stats'			=> array('lang' => 'ARCADE_SEARCH_STATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'links_stats'			=> array('lang' => 'ARCADE_LINKS_STATS', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'acp_items_per_page'	=> array('lang' => 'ARCADE_ACP_ITEMS_PER_PAGE', 'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'stat_items_per_page'	=> array('lang' => 'ARCADE_STAT_ITEMS_PER_PAGE',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'most_popular'			=> array('lang' => 'ARCADE_MOST_POPULAR',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'least_popular'			=> array('lang' => 'ARCADE_LEAST_POPULAR',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'most_downloaded'		=> array('lang' => 'ARCADE_MOST_DOWNLOADED',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'least_downloaded'		=> array('lang' => 'ARCADE_LEAST_DOWNLOADED',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'longest_held_scores'	=> array('lang' => 'ARCADE_LONGEST_HELD_SCORES',	'int' => 'string', 'type' => 'text:3:4', 'explain' => true),
				'arcade_leaders_header'	=> array('lang' => 'ARCADE_LEADERS_HEADER',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'arcade_leaders'		=> array('lang' => 'ARCADE_LEADERS',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'newest_games'			=> array('lang' => 'ARCADE_NEWEST_GAMES',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'latest_highscores'		=> array('lang' => 'ARCADE_LATEST_HIGHSCORES',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'game_scores'			=> array('lang' => 'ARCADE_TOTAL_GAME_SCORES',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),

				'legend6'				=> 'ACP_ARCADE_SETTINGS_PROTECT',
				'protect_amod'			=> array('lang' => 'ARCADE_PROTECT_AMOD', 		'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'protect_ibpro'			=> array('lang' => 'ARCADE_PROTECT_IBPRO', 		'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'protect_v3arcade'		=> array('lang' => 'ARCADE_PROTECT_V3ARCADE', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),

				'legend7'				=> 'ACP_ARCADE_SETTINGS_PM',
				'send_arcade_pm'		=> array('lang' => 'ARCADE_SEND_PM', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'pm_subject'			=> array('lang' => 'ARCADE_PM_SUBJECT',	'validate' => 'string', 'type' => 'textarea:5:25', 'explain' => true),
				'pm_message'			=> array('lang' => 'ARCADE_PM_MESSAGE',	'validate' => 'string', 'type' => 'textarea:8:25', 'explain' => true),

				'legend8'				=> 'ACP_ARCADE_SETTINGS_ANNOUNCE',
				'announce_game'			=> array('lang' => 'ARCADE_ANNOUNCE_GAME', 	'validate' => 'bool', 'type' => 'radio:yes_no', 'explain' => true),
				'announce_forum'		=> array('lang' => 'ARCADE_ANNOUNCE_FORUM',  'validate' => 'string', 'type' => 'select', 'method' => 'arcade_announce_game', 'explain' => true),
				'announce_subject'		=> array('lang' => 'ARCADE_ANNOUNCE_SUBJECT',	'validate' => 'string', 'type' => 'textarea:5:25', 'explain' => true),
				'announce_message'		=> array('lang' => 'ARCADE_ANNOUNCE_MESSAGE',	'validate' => 'string', 'type' => 'textarea:8:25', 'explain' => true),

				'legend9'						=> 'ACP_ARCADE_SETTINGS_PLAY',
				'limit_play'					=> array('lang' => 'ARCADE_LIMIT_PLAY',  'validate' => 'int', 'type' => 'select', 'method' => 'arcade_limit_play_select', 'explain' => true),
				'limit_play_total_posts'		=> array('lang' => 'ARCADE_LIMIT_PLAY_TOTAL_POSTS',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'limit_play_posts'				=> array('lang' => 'ARCADE_LIMIT_PLAY_POSTS',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),
				'limit_play_days'				=> array('lang' => 'ARCADE_LIMIT_PLAY_DAYS',	'validate' => 'int', 'type' => 'text:3:4', 'explain' => true),

			)
		);

		$this->new_config = $arcade->config;
		$cfg_array = (isset($_REQUEST['config'])) ? utf8_normalize_nfc(request_var('config', array('' => ''), true)) : $this->new_config;
		$error = array();

		// We validate the complete config if whished
		validate_config_vars($display_vars['vars'], $cfg_array, $error);

		if ($update && !check_form_key($form_key))
		{
			$error[] = $user->lang['FORM_INVALID'];
		}

		// Do not write values if there is an error
		if (sizeof($error))
		{
			$update = false;
		}

		// We go through the display_vars to make sure no one is trying to set variables he/she is not allowed to...
		foreach ($display_vars['vars'] as $config_name => $null)
		{
			if (!isset($cfg_array[$config_name]) || strpos($config_name, 'legend') !== false)
			{
				continue;
			}

			$config_value = $cfg_array[$config_name];
			$this->new_config[$config_name] = $config_value;

			if ($update)
			{
				$arcade->set_config($config_name, $config_value);
			}
		}

		if ($update)
		{
			add_log('admin', 'LOG_ARCADE_' . strtoupper($mode));
			$cache->destroy('sql', ARCADE_CATS_TABLE);
			$cache->destroy('sql', ARCADE_GAMES_TABLE);
			$cache->destroy('sql', ARCADE_SCORES_TABLE);
			$cache->destroy('_arcade_all_games');
			$cache->destroy('_arcade_cats');
			$cache->destroy('_arcade_leaders');
			$cache->destroy('_arcade_leaders_all');
			trigger_error($user->lang['CONFIG_UPDATED'] . adm_back_link($this->u_action));
		}

		// Output relevant page
		foreach ($display_vars['vars'] as $config_key => $vars)
		{

			if (!is_array($vars) && strpos($config_key, 'legend') === false)
			{
				continue;
			}

			if (strpos($config_key, 'legend') !== false)
			{
				$template->assign_block_vars('options', array(
					'S_LEGEND'	=> true,
					'LEGEND'		=> $user->lang[$vars])
				);

				continue;
			}

			$type = explode(':', $vars['type']);

			$template->assign_block_vars('options', array(
				'KEY'			=> $config_key,
				'TITLE'			=> $user->lang[$vars['lang']],
				'S_EXPLAIN'		=> $vars['explain'],
				'TITLE_EXPLAIN'	=> ($vars['explain']) ? $user->lang[$vars['lang'] . '_EXPLAIN'] : '',
				'CONTENT'		=> build_cfg_template($type, $config_key, $this->new_config, $config_key, $vars),
				)
			);

			unset($display_vars['vars'][$config_key]);
		}

		if (isset($display_vars['lang']))
		{
			$user->add_lang($display_vars['lang']);
		}

		$this->page_title = $display_vars['title'];

		$template->assign_vars(array(
				'L_TITLE'			=> $user->lang[$display_vars['title']],
				'L_TITLE_EXPLAIN'	=> $user->lang[$display_vars['title_explain']],

				'S_ERROR'			=> (sizeof($error)) ? true : false,
				'ERROR_MSG'			=> implode('<br />', $error),

				'U_ACTION'			=> $this->u_action)
		);
	}

	function manage_version_check()
	{
		global $db, $user, $auth, $auth_arcade, $template, $cache, $table_prefix, $arcade;
		global $config, $phpbb_admin_path, $phpbb_root_path, $phpEx;

		$user->add_lang('install');
		$this->page_title = 'ACP_VERSION_CHECK';
		$current_version = str_replace(' ', '.', $arcade->config['version']);

		// Get current and latest version
		$errstr = '';
		$errno = 0;

		$info = get_remote_file('www.jeffrusso.net', '/updatecheck', 'phpBBArcade.txt', $errstr, $errno);

		if ($info === false)
		{
			trigger_error($errstr, E_USER_WARNING);
		}

		$info = explode("\n", $info);
		$latest_version = trim($info[0]);

		$announcement_url = trim($info[1]);
		$update_link = append_sid($phpbb_root_path . 'arcade_install/install.' . $phpEx);

		$up_to_date = (version_compare(str_replace('rc', 'RC', strtolower($current_version)), str_replace('rc', 'RC', strtolower($latest_version)), '<')) ? false : true;

		$template->assign_vars(array(
			'S_VERSION_CHECK'	=> true,
			'S_UP_TO_DATE'		=> $up_to_date,

			'LATEST_VERSION'	=> $latest_version,
			'CURRENT_VERSION'	=> $current_version,

			'UPDATE_INSTRUCTIONS'	=> sprintf($user->lang['ARCADE_UPDATE_INSTRUCTIONS'], $announcement_url, $update_link),
		));
	}

	function arcade_version()
	{
		global $arcade, $user;

		return $arcade->config['version'] . '&nbsp;&nbsp;&nbsp;<input class="button1" type="submit" id="submit" name="version_check" value="' . $user->lang['ARCADE_CHECK_UPDATES'] . '" />';
	}

	function arcade_announce_game($value, $key = '')
	{
		return make_forum_select($value, false, true, true, true, false, false);
	}

	function arcade_limit_play_select($value, $key = '')
	{
		global $user;

		return '<option value="' . LIMIT_PLAY_TYPE_NONE .'"'. (($value == LIMIT_PLAY_TYPE_NONE) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_NONE'] . '</option><option value="' . LIMIT_PLAY_TYPE_POSTS . '"' . (($value == LIMIT_PLAY_TYPE_POSTS) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_TOTAL_POSTS'] . '</option><option value="' . LIMIT_PLAY_TYPE_DAYS . '"' . (($value == LIMIT_PLAY_TYPE_DAYS) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_POSTS'] . '</option><option value="' . LIMIT_PLAY_TYPE_BOTH . '"' . (($value == LIMIT_PLAY_TYPE_BOTH) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_LIMIT_PLAY_BOTH'] . '</option>';
	}

	function games_sort_order_select($value, $key = '')
	{
		global $user;

		return '<option value="' . ARCADE_ORDER_FIXED .'"'. (($value == ARCADE_ORDER_FIXED) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_FIXED'] . '</option><option value="' . ARCADE_ORDER_INSTALLDATE .'"'. (($value == ARCADE_ORDER_INSTALLDATE) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_INSTALLDATE'] . '</option><option value="' . ARCADE_ORDER_NAME . '"' . (($value == ARCADE_ORDER_NAME) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_NAME'] . '</option><option value="' . ARCADE_ORDER_PLAYS . '"' . (($value == ARCADE_ORDER_PLAYS) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_PLAYS'] . '</option><option value="' . ARCADE_ORDER_RATING . '"' . (($value == ARCADE_ORDER_RATING) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_RATING'] . '</option>';
	}

	function games_sort_dir_select($value, $key = '')
	{
		global $user;

		return '<option value="' . ARCADE_ORDER_ASC . '"' . (($value == ARCADE_ORDER_ASC) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_ASC'] . '</option><option value="' . ARCADE_ORDER_DESC . '"' . (($value == ARCADE_ORDER_DESC) ? ' selected="selected"' : '') . '>' . $user->lang['ARCADE_GAMES_SORT_DESC'] . '</option>';
	}

	/**
	* Arcade disable option and message
	*/
	function arcade_disable($value, $key)
	{
		global $user;

		$radio_ary = array(1 => 'YES', 0 => 'NO');

		return h_radio('config[arcade_disable]', $radio_ary, $value) . '<br /><input id="' . $key . '" type="text" name="config[arcade_disable_msg]" maxlength="255" size="40" value="' . $this->new_config['arcade_disable_msg'] . '" />';
	}


}
?>