<?php
/**
*
* @package arcade
* @version $Id: arcade_compress.php 240 2008-05-05 15:34:36Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* Class for extracting tar files, extends functions_compress.php
* @package arcade
*/
class compress_tar_arcade extends compress_tar
{
	/**
	* Extract archive
	*/
	function extract($dst)
	{
		$fzread = ($this->isbz && function_exists('bzread')) ? 'bzread' : (($this->isgz && @extension_loaded('zlib')) ? 'gzread' : 'fread');

		// Run through the file and grab directory entries
		while ($buffer = $fzread($this->fp, 512))
		{
			$tmp = unpack('A6magic', substr($buffer, 257, 6));

			if (trim($tmp['magic']) == 'ustar')
			{
				$tmp = unpack('A100name', $buffer);
				$filename = trim($tmp['name']);

				$tmp = unpack('Atype', substr($buffer, 156, 1));
				$filetype = (int) trim($tmp['type']);

				$tmp = unpack('A12size', substr($buffer, 124, 12));
				$filesize = octdec((int) trim($tmp['size']));

				if ($filetype == 5)
				{
					if (!is_dir("$dst$filename"))
					{
						$str = '';
						$folders = explode('/', "$dst$filename");

						// Create and folders and subfolders if they do not exist
						foreach ($folders as $folder)
						{
							$str = (!empty($str)) ? $str . '/' . $folder : $folder;
							if (!is_dir($str))
							{
								if (!@mkdir($str, 0777))
								{
									trigger_error("Could not create directory $folder");
								}
								@chmod($str, 0777);
							}
						}
					}
				}
				else if ($filesize >= 0 && ($filetype == 0 || $filetype == "\0"))
				{
					$str = '';
					$target_filename = "$dst$filename";
					$folders = explode('/', pathinfo($target_filename, PATHINFO_DIRNAME));

					// Create and folders and subfolders if they do not exist
					foreach ($folders as $folder)
					{
						$str = (!empty($str)) ? $str . '/' . $folder : $folder;
						if (!is_dir($str))
						{
							if (!@mkdir($str, 0777))
							{
								trigger_error("Could not create directory $folder");
							}
							@chmod($str, 0777);
						}
					}

					// Write out the files
					if (!($fp = fopen("$dst$filename", 'wb')))
					{
						trigger_error("Couldn't create file $filename");
					}
					@chmod("$dst$filename", 0777);

					// Grab the file contents
					fwrite($fp, ($filesize) ? $fzread($this->fp, ($filesize + 511) &~ 511) : '', $filesize);
					fclose($fp);
				}
			}
		}
	}

}

?>