<?php
/**
*
* @package arcade
* @version $Id: arcade_download.php 297 2008-06-06 19:38:33Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (!$game_id)
{
	trigger_error('NO_GAME_ID');
}

$game_info = $arcade->get_game_data($game_id);

$s_download = false;
if ($game_info['cat_download'])
{
	if ($game_info['game_download'])
	{
		if ($auth_arcade->acl_get('c_download', $game_info['cat_id']))
		{
			$s_download = true;
		}
	}
}

if (!$s_download)
{
	trigger_error('NO_PERMISSION_ARCADE_DOWNLOAD');
}

generate_arcade_nav($game_info, true);

$use_method = request_var('use_method', '');
$methods = $arcade->compress_methods();

// Let the user decide in which format he wants to have the game downloaded in
if (!$use_method)
{
	$page_title = sprintf($user->lang['ARCADE_DOWNLOAD_FORMAT'], $game_info['game_name']);

	$radio_buttons = '';
	foreach ($methods as $method)
	{
		$radio_buttons .= '<input type="radio"' . ((!$radio_buttons) ? ' id="use_method"' : '') . ' class="radio" value="' . $method . '" name="use_method" />&nbsp;' . $method . '&nbsp;';
	}

	$template->assign_vars(array(
		'S_SELECT_METHOD'			=> true,
		'GAME_NAME'					=> $game_info['game_name'],
		'ARCADE_DOWNLOAD_FORMAT' 	=> $page_title,
		'U_ACTION'					=> append_sid("arcade.php", "mode=download&amp;g=$game_id"),
		'RADIO_BUTTONS'				=> $radio_buttons)
	);

	display_arcade_online();
	// Output page
	page_header($page_title, false);

	$template->set_filenames(array(
		'body' => 'arcade/arcade_download_body.html')
	);

	page_footer();
	exit;
}

$arcade->update_download_total($game_id);
$cache->destroy('_arcade_totals');
$cache->destroy('sql', ARCADE_GAMES_TABLE);

include($phpbb_root_path . 'includes/functions_compress.' . $phpEx);
include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);

$filename = remove_extension($game_info['game_swf']);
$extra_game_files = ($game_info['game_files'] != '') ? unserialize($game_info['game_files']) : '';
$error = array();
if (is_array($extra_game_files))
{
	foreach ($extra_game_files as $file)
	{
		if (!file_exists($file))
		{
			$error[] = $file;
		}
	}
}

if (sizeof($error))
{
	trigger_error(sprintf($user->lang['ARCADE_DOWNLOAD_MISSING_FILES'], implode('<br />', $error)));
}



if (!in_array($use_method, $methods))
{
	$use_method = '.tar';
}

if ($use_method == '.zip')
{
	$compress = new compress_zip('w', $phpbb_root_path . 'store/' . $filename . $use_method);
}
else
{
	$compress = new compress_tar('w', $phpbb_root_path . 'store/' . $filename . $use_method, $use_method);
}

// Get the main game files
$game_files = filelist($phpbb_root_path . $arcade->config['game_path'], $filename, 'php|gif|swf|png|jpg|jpeg');
$game_files = $game_files[$filename. '/'];

// Write files in folders
add_game_to_archive($compress, $game_files, $filename);

// Check if game has extra files needed to run and add them to archive...
if (is_array($extra_game_files))
{
	$dir = $old_dir = '';

	foreach ($extra_game_files as $file)
	{
		$compress->add_custom_file($file, $file);

		// If this is a new directory add a blank index.htm file...
		$dir = dirname($file);
		if ($old_dir != $dir)
		{
			$compress->add_data('', $dir . '/index.htm');
			$old_dir = $dir;
		}
	}
}

// index.htm files
$compress->add_data('', $arcade->config['game_path'] . $filename . '/index.htm');
$compress->close();

// Send file to the browser for download
$compress->download($filename);
// Delete file from the store once user downloads it
@unlink($phpbb_root_path . 'store/' . $filename . $use_method);

exit;
?>