<?php
/**
*
* @package arcade
* @version $Id: arcade_protect.php 292 2008-06-02 13:08:22Z jrsweets $
* @copyright (c) 2008 http://www.JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

require($phpbb_root_path . 'config.' . $phpEx);
require($phpbb_root_path . 'includes/acm/acm_' . $acm_type . '.' . $phpEx);
require($phpbb_root_path . 'includes/cache.' . $phpEx);
require($phpbb_root_path . 'includes/db/' . $dbms . '.' . $phpEx);
require($phpbb_root_path . 'includes/constants.' . $phpEx);

require($phpbb_root_path . 'includes/arcade/arcade_constants.' . $phpEx);
require($phpbb_root_path . 'includes/arcade/functions_arcade.' . $phpEx);
require($phpbb_root_path . 'includes/arcade/arcade_cache.' . $phpEx);

$db = new $sql_db();
// Connect to DB
if (!@$db->sql_connect($dbhost, $dbuser, $dbpasswd, $dbname, $dbport, false, false))
{
	exit;
}
unset($dbpasswd);

// worst-case default
$browser = (!empty($_SERVER['HTTP_USER_AGENT'])) ? htmlspecialchars((string) $_SERVER['HTTP_USER_AGENT']) : 'msie 6.0';

$cache = new arcade_cache();
$config = $cache->obtain_arcade_config();

if (isset($_GET['swf']))
{
	$filename = (string) $_GET['swf'];

	if (!$filename)
	{
		header("HTTP/1.0 403 Forbidden");
		if (!empty($cache))
		{
			$cache->unload();
		}
		$db->sql_close();
		exit;
	}

	send_swf_to_browser($filename, $browser);

	if (!empty($cache))
	{
		$cache->unload();
	}
	$db->sql_close();
	exit;
}

if (isset($_GET['img']))
{
	$filename = (string) $_GET['img'];

	// '==' is not a bug - . as the first char is as bad as no dot at all
	if (strpos($filename, '.') == false)
	{
		header('HTTP/1.0 403 Forbidden');
		if (!empty($cache))
		{
			$cache->unload();
		}
		$db->sql_close();
		exit;
	}

	$ext = substr(strrchr($filename, '.'), 1);

	if (!in_array($ext, array('png', 'gif', 'jpg', 'jpeg')))
	{
		header("HTTP/1.0 403 Forbidden");
		if (!empty($cache))
		{
			$cache->unload();
		}
		$db->sql_close();
		exit;
	}

	if (!$filename)
	{
		header("HTTP/1.0 403 Forbidden");
		if (!empty($cache))
		{
			$cache->unload();
		}
		$db->sql_close();
		exit;
	}

	send_img_to_browser($filename, $browser);

	if (!empty($cache))
	{
		$cache->unload();
	}
	$db->sql_close();
	exit;
}
exit;
?>