<?php
/**
* acp_permissions_arcade  (phpBB Arcade Permission Set) [English]
*
* @package language
* @version $Id: permissions_arcade.php 285 2008-05-27 00:51:41Z jrsweets $
* @copyright (c) 2008 JeffRusso.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

/**
* DO NOT CHANGE
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

// DEVELOPERS PLEASE NOTE
//
// All language files should use UTF-8 as their encoding and the files must not contain a BOM.
//
// Placeholders can now contain order information, e.g. instead of
// 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
// translators to re-order the output of data while ensuring it remains correct
//
// You do not need this where single placeholders are used, e.g. 'Message %d' is fine
// equally where a string contains only two placeholders which are used to wrap text
// in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine

/**
*	MODDERS PLEASE NOTE
*
*	You are able to put your permission sets into a seperate file too by
*	prefixing the new file with permissions_ and putting it into the acp
*	language folder.
*
*	An example of how the file could look like:
*
*	<code>
*
*	if (empty($lang) || !is_array($lang))
*	{
*		$lang = array();
*	}
*
*	// Adding new category
*	$lang['permission_cat']['bugs'] = 'Bugs';
*
*	// Adding new permission set
*	$lang['permission_type']['bug_'] = 'Bug Permissions';
*
*	// Adding the permissions
*	$lang = array_merge($lang, array(
*		'acl_bug_view'		=> array('lang' => 'Can view bug reports', 'cat' => 'bugs'),
*		'acl_bug_post'		=> array('lang' => 'Can post bugs', 'cat' => 'post'), // Using a phpBB category here
*	));
*
*	</code>
*/

// Define categories and permission types
$lang['permission_cat']['arcade'] = 'משחקית phpBB';

// Admin Permissions
$lang = array_merge($lang, array(
	'acl_a_cauth'				=> array('lang' => 'יכול לשנות את הרשאת כיתת המשחקיה', 'cat' => 'arcade'),
	'acl_a_arcade_settings'		=> array('lang' => 'יכול לנהל את הגדרות המשחקיה', 'cat' => 'arcade'),
	'acl_a_arcade_game'			=> array('lang' => 'יכול להוסיף/לערוך משחקים במשחקיה ', 'cat' => 'arcade'),
	'acl_a_arcade_delete_game'	=> array('lang' => 'יכול למחוק משחקים מהמשחקיה', 'cat' => 'arcade'),
	'acl_a_arcade_cat'			=> array('lang' => 'יכול להוסיף/לערוך קטגורייות למשחקיה', 'cat' => 'arcade'),
	'acl_a_arcade_delete_cat'	=> array('lang' => 'יכול למחוק את קטגורייות המשחקיה', 'cat' => 'arcade'),
	'acl_a_arcade_scores'		=> array('lang' => 'יכול לערוך את נקודות המשחקים', 'cat' => 'arcade'),
	'acl_a_arcade_utilities'	=> array('lang' => 'יכול להשתמש במשחקיה', 'cat' => 'arcade'),
));

$lang['permission_type']['c_'] = 'Arcade Local Category Permissions';

$lang = array_merge($lang, array(
	'acl_c_list'					=> array('lang' => 'יכול לרשום קטגורייה', 'cat' => 'arcade'),
	'acl_c_view'					=> array('lang' => 'יכול לצפות בקטגורייה', 'cat' => 'arcade'),
	'acl_c_play'					=> array('lang' => 'יכול לשחק במשחקיה', 'cat' => 'arcade'),
	'acl_c_popup'                                   => array('lang' => 'יכול לשחק משחקים במשחקיה בחלון חדש', 'cat' => 'arcade'), 
	'acl_c_popup'					=> array('lang' => 'יכול לשחק במשחקים של המשחקיה בחלון חדש', 'cat' => 'arcade'),
	'acl_c_score'					=> array('lang' => 'יכול לשלוח ניקוד', 'cat' => 'arcade'),
	'acl_c_rate'					=> array('lang' => 'יכול לדרג משחקים', 'cat' => 'arcade'),
	'acl_c_comment'					=> array('lang' => 'יכול לשלוח הערות', 'cat' => 'arcade'),
	'acl_c_download'				=> array('lang' => 'יכול להוריד משחקים מהמשחקיה', 'cat' => 'arcade'),
	'acl_c_ignorecontrol'			=> array('lang' => 'יכול לנטרל את השליטה במשחקים', 'cat' => 'arcade'),
	'acl_c_resolution'				=> array('lang' => 'יכול לשנות רזולוצייה של משחק', 'cat' => 'arcade'),
));


?>